package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class BasicStatistic extends GenericRScript {

	static class opIO16f7415cce60d4ff2b848bb1d2747344e extends DynamicEnum {
		public enum EopIO16f7415cce60d4ff2b848bb1d2747344e {};
		public Field[] getFields() {
			Field[] fields = EopIO16f7415cce60d4ff2b848bb1d2747344e.class.getDeclaredFields();
			return fields;
		}
	}

	@Override
	public String getDescription() {
		return "Basic statistic max min average";
	}

	protected void initVariables(){
		mainScriptName="BasicStatistic/Main.R";
		packageURL="http://data.d4science.org/MzE3Ky8zVk15STFMZzYydnA2NXFzaHlmZVkvTzc5Rk1HbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("operator");
		inputvariables.add("limit");
		inputvariables.add("file1");
		outputvariables.add("output");
	}

	@Override
	protected void setInputParameters() {
		if (org.gcube.dataanalysis.executor.rscripts.BasicStatistic.opIO16f7415cce60d4ff2b848bb1d2747344e.EopIO16f7415cce60d4ff2b848bb1d2747344e.values().length==0){
			opIO16f7415cce60d4ff2b848bb1d2747344e en = new opIO16f7415cce60d4ff2b848bb1d2747344e();
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.BasicStatistic.opIO16f7415cce60d4ff2b848bb1d2747344e.EopIO16f7415cce60d4ff2b848bb1d2747344e.class, "max");
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.BasicStatistic.opIO16f7415cce60d4ff2b848bb1d2747344e.EopIO16f7415cce60d4ff2b848bb1d2747344e.class, "min");
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.BasicStatistic.opIO16f7415cce60d4ff2b848bb1d2747344e.EopIO16f7415cce60d4ff2b848bb1d2747344e.class, "average");
		}

		addEnumerateInput(org.gcube.dataanalysis.executor.rscripts.BasicStatistic.opIO16f7415cce60d4ff2b848bb1d2747344e.EopIO16f7415cce60d4ff2b848bb1d2747344e.values(), "operator", "operator (max, min, average)", "max");
		inputs.add(new PrimitiveType(Integer.class.getName(), null,PrimitiveTypes.NUMBER, "limit", "limit (-1 for no limit)", "-1"));
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "file1", "input file", "test.txt"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("output",new PrimitiveType(File.class.getName(), new File(outputValues.get("output")), PrimitiveTypes.FILE, "output", "output"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
